#########################
# Please note that I am not a programmer and that this script is very crude. 
# Nevertheless, it should do its job (when I run it anyway :-))
# Please contact me at alainfrantz@yahoo.co.uk if you have questions
###############################


rm(list=ls())
library(Geneland)

kin1 <-read.table('kinship.txt', header=TRUE, sep = "\t") 
kin1<-kin1[c(which(kin1$Spatial.dist != "-99")),]
kin2<-data.frame(kin1, ln.dist=log(kin1$Spatial.dist))
samples <-read.table('samples.txt', header=T, sep = "\t")
geno<-read.table('geno.txt', header=F, sep = "\t") 
Fstat1<-Fstat(geno,npop=2,as.matrix(samples[,2]))


look.up<-data.frame(locations=samples[,1],new.loc=samples[,2])
loc.rand<-function(orig.dat,loc.num,idx){
	# location is column from 
	# loc.num is location 1 or 2
	wrk<-orig.dat[orig.dat[,loc.num]==as.character(look.up$locations[idx]),]
	wrk[,(dim(wrk)[2]+1)]<-rep(look.up$new.loc[idx],length(wrk$Namei))
	names(wrk)[dim(wrk)[2]]<-paste("new.loc",loc.num,sep="")
	wrk
	}

collect.emp.slope1<-data.frame(matrix(0,1,10))
names(collect.emp.slope1)<-c("within_all","r-sq","rel","among_all","r-sq","rel","within_min_emp","r-sq","rel","fst")

make.karl.data<-function(orig.dat,locs,no.unique.locations){
	
	# orig dat is fst or ds north or south
	# locs is original locations in look up table
	# uniques.locations is NUMBER of unique locations (e.g. dim(look ups))

	# BEGIN PROCESSING
	# first deal with location 1
	out<-data.frame(matrix(0,0,9))
	names(out)<-c(names(orig.dat),"new.loc1")

	# Loop 1 - cycle through the names and replace all of the location 1's
	# 
	for(i in 1:no.unique.locations){
		oo<-loc.rand(orig.dat,1,i)
		out<-rbind(out,oo)
		}

	# NOW sort against location 2 and run loc.2 function to replace
	o<-order(out$Namej)
	pp<-out[o,]

	out2<-data.frame(matrix(0,0,10))
	names(out2)<-c(names(pp),"new.loc2")
	for(i in 1:no.unique.locations){
		oo<-loc.rand(pp,2,i)
		out2<-rbind(out2,oo)
	}

	# Look out output
	out2
	# get dimension 1
	ll<-dim(out2)[1]

	# loop through and re-code r and u from string
	#for(i in 1:ll){
	#	out2$code1[i]<-ifelse(unlist(strsplit(as.character(out2$new.loc1[i]),split="-"))[2]=="F","F","M")
	#	out2$code2[i]<-ifelse(unlist(strsplit(as.character(out2$new.loc2[i]),split="-"))[2]=="F","F","M")
	#	}

	# past together for final code column
	#out2$code.new<-paste(out2$code1,out2$code2,sep="-")

	# collect working columns for analysis/
	work.on.this<-out2[,c(9,10,7,8)]
	#work.on.this<-out2
	work.on.this
	}

no.unique.north<-dim(look.up)[1]

wrk<-make.karl.data(kin2,look.up$locations,no.unique.north)



datax1<-wrk[-c(which(wrk$new.loc1 == wrk$new.loc2)),]
datax2<-wrk[c(which(wrk$new.loc1 == wrk$new.loc2)),]
minimum<-min(datax1$ln.dist)
min_m<-exp(minimum)
datax2b<-datax2[c(which(datax2$ln.dist >= minimum)),]

bla1<-lm(Pairwise~ln.dist,data=datax1)
bla2<-lm(Pairwise~ln.dist,data=datax2)
bla3<-lm(Pairwise~ln.dist,data=datax2b)
collect.emp.slope1[1,][4]<-bla1$coefficients[2]
collect.emp.slope1[1,][5]<-summary(bla1)[8]$r.squared
collect.emp.slope1[1,][6]<-mean(datax1$Pairwise)
collect.emp.slope1[1,][1]<-bla2$coefficients[2]
collect.emp.slope1[1,][2]<-summary(bla2)[8]$r.squared
collect.emp.slope1[1,][3]<-mean(datax2$Pairwise)
collect.emp.slope1[1,][7]<-bla3$coefficients[2]
collect.emp.slope1[1,][8]<-summary(bla3)[8]$r.squared
collect.emp.slope1[1,][9]<-mean(datax2b$Pairwise)
collect.emp.slope1[1,][10]<-Fstat1$Fst[2,1]

write.csv(collect.emp.slope1, "emp.slopesb.csv")

####
# now create random
#####

#library(random)

qwertz<-Sys.time()
ID<-(as.numeric(paste(
unlist(strsplit((as.character(qwertz)),split=":"))[2],
unlist(strsplit((as.character(qwertz)),split=":"))[3],
sep="")))
ID<-paste("X",ID,sep="")


####################################
# please give the number of random coordinates 
#simulated for the straight lines
#########################################
n.sim<-50
#################################3

samples <-read.table("samples.txt", header=T, sep = "\t") 

min.x<-min(samples[,3])
min.y<-min(samples[,4])
max.x<-max(samples[,3])
max.y<-max(samples[,4])
min.x<-as.numeric(unlist(strsplit((as.character(min.x)),split="\\."))[1])
min.x
min.y<-as.numeric(unlist(strsplit((as.character(min.y)),split="\\."))[1])
min.y
max.x<-as.numeric(unlist(strsplit((as.character(max.x)),split="\\."))[1])
max.x
max.y<-as.numeric(unlist(strsplit((as.character(max.y)),split="\\."))[1])
max.y


#rand1<-randomNumbers(n=n.sim, min=min.x, max=max.x, col=1, check=T)
#rand2<-randomNumbers(n=n.sim, min=min.y, max=max.y, col=1)

rand1<-sample(min.x:max.x, n.sim)
rand2<-sample(min.y:max.y, n.sim)

random<-data.frame(rand1,rand2)
names(random)<-c("x","y")

no.rand<-nrow(random)/2

table1<-data.frame(matrix(0,no.rand,2))
names(table1)<-c("intercept","slope")


# loop

for(i in 1:no.rand){
mydata<-random[(2*i-1):(2*i),]
table1[i,][1]<-lm(y~x,data=mydata)$coefficients[1]
table1[i,][2]<-lm(y~x,data=mydata)$coefficients[2]
print(i)
}


new<-data.frame(samples, matrix(0,nrow(samples),nrow(table1)))
names<-names(new)
min<-data.frame(samples[1,],matrix(0,1,nrow(table1)))

for(i in 1:nrow(table1)){
intercept<-table1[i,1]
slope<-table1[i,2]
new[,4+i]<-ifelse(samples[,4]>= (samples[,3]*slope)+intercept,1,2)
min[,4+i]<-min((sum(new[c(which(new[,4+i] == 1)),][,4+i])),(sum(new[c(which(new[,4+i] == 2)),][,4+i])/2))
print(i)
}


id_m<-data.frame(matrix(0,nrow(samples),1))
id_m[,1]<-ID
names(id_m)<-as.character(ID)


new1<-rbind(min,new)
new2<-new1[,c(which(new1[1,] >= 30))]
incl<-dim(new2)[2]

new3<-data.frame(samples,new2[2:(nrow(samples)+1),4:incl])

new3_1<-as.matrix(data.frame(id_m,new3,(matrix(0,(nrow(samples)),((no.rand+2)-incl)))))

size<-length(names(new3[,5:dim(new3)[2]]))

newfst<-data.frame(matrix(0,size,2))

newfst[,1]<-names(new3[,5:dim(new3)[2]])

for(i in 1:size){
newfst[i,2]<-Fstat(geno,npop=2,as.matrix(new3[,4+i]))$Fst[2,1]
print(i)}


#write.csv(new3_1,"new3.csv")

#write.csv(newfst,"newfst.csv")

names.out<-data.frame(names(new3))

kin1 <-read.table("kinship.txt", header=TRUE, sep = "\t") 
kin2<-kin1[c(which(kin1$Spatial.dist != "-99")),]
kin2<-data.frame(kin2, ln.dist=log((kin2$Spatial.dist)))

locations<-unique(c(as.character(kin1$Namei),as.character(kin1$Namej)))

look.up<-data.frame(locations,new.loc=new3[,5])

loc.rand<-function(orig.dat,loc.num,idx){
	# location is column from 
	# loc.num is location 1 or 2
	wrk<-orig.dat[orig.dat[,loc.num]==as.character(look.up$locations[idx]),]
	wrk[,(dim(wrk)[2]+1)]<-rep(look.up$new.loc[idx],length(wrk$Namei))
	names(wrk)[dim(wrk)[2]]<-paste("new.loc",loc.num,sep="")
	wrk
	}


########################################################
# Master Function to randomise across locations
##########################################################

make.karl.data<-function(orig.dat,locs,no.unique.locations){
	
	# orig dat is fst or ds north or south
	# locs is original locations in look up table
	# uniques.locations is NUMBER of unique locations (e.g. dim(look ups))

	# BEGIN PROCESSING
	# first deal with location 1
	out<-data.frame(matrix(0,0,9))
	names(out)<-c(names(orig.dat),"new.loc1")

	# Loop 1 - cycle through the names and replace all of the location 1's
	# 
	for(i in 1:no.unique.locations){
		oo<-loc.rand(orig.dat,1,i)
		out<-rbind(out,oo)		
		}

	# NOW sort against location 2 and run loc.2 function to replace
	o<-order(out$Namej)
	pp<-out[o,]

	out2<-data.frame(matrix(0,0,10))
	names(out2)<-c(names(pp),"new.loc2")
	for(i in 1:no.unique.locations){
		oo<-loc.rand(pp,2,i)
		out2<-rbind(out2,oo)
	}

	# Look out output
	out2
	# get dimension 1
	ll<-dim(out2)[1]

	# loop through and re-code r and u from string
	#for(i in 1:ll){
	#	out2$code1[i]<-ifelse(unlist(strsplit(as.character(out2$new.loc1[i]),split="-"))[2]=="F","F","M")
	#	out2$code2[i]<-ifelse(unlist(strsplit(as.character(out2$new.loc2[i]),split="-"))[2]=="F","F","M")
	#	}

	# past together for final code column
	#out2$code.new<-paste(out2$code1,out2$code2,sep="-")

	# collect working columns for analysis/
	work.on.this<-out2[,c(9,10,7,8)]
	#work.on.this<-out2
	work.on.this
	}

# RANDOMISE


# RANDOMISE

# setup
nits<-length(new3)-4
no.unique.north<-length(locations)

# collection matrices for each 
collect.slope<-data.frame(matrix(0,nits,15))
collect.slope[,1]<-ID
collect.slope[,2]<-names.out[5:(dim(names.out)[1]),]
collect.slope[,15]<-newfst[,2]
names(collect.slope)<-c("ID","no.coord","within_all","r-sq","rel","among_all","r-sq","rel","within_min_emp","r-sq","rel","among_min_emp","r-sq","rel","FST")

namesnew3<-data.frame(names.cl<-names(new3)[5:length(new3)])
names(namesnew3)<-"xx"
clusterb<-data.frame(t(new3[,5:length(new3)]))
collect.slope<-data.frame(collect.slope,namesnew3,clusterb)

# loop
for(i in 1:nits){
	look.up<-data.frame(locations,new.loc=new3[,4+i])
	#look.up<-data.frame(locations,new.loc=sample(locations,no.unique.north))
	wrk<-make.karl.data(kin2,look.up$locations,no.unique.north)
	
datay1<-wrk[c(which(wrk$new.loc1 == wrk$new.loc2)),]
datay2<-wrk[-c(which(wrk$new.loc1 == wrk$new.loc2)),]
datay1b<-datay1[c(which(datay1$ln.dist >= minimum)),]
datay2b<-datay2[c(which(datay2$ln.dist >= minimum)),]
#mini22<-min(datay2$ln.dist)
#datay1c<-datay1[c(which(datay1$ln.dist >= mini22)),]

ha1<-lm(Pairwise~ln.dist,data=datay1)
ha2<-lm(Pairwise~ln.dist,data=datay2)
ha3<-lm(Pairwise~ln.dist,data=datay1b)
ha4<-lm(Pairwise~ln.dist,data=datay2b)


	#collect.slope[i,][2]<-names.out[4+i,]
	collect.slope[i,][3]<-ha1$coefficients[2]
	collect.slope[i,][4]<-summary(ha1)[8]$r.squared
	collect.slope[i,][5]<-mean(datay1$Pairwise)
	collect.slope[i,][6]<-ha2$coefficients[2]
	collect.slope[i,][7]<-summary(ha2)[8]$r.squared
	collect.slope[i,][8]<-mean(datay2$Pairwise)
	collect.slope[i,][9]<-ha3$coefficients[2]
	collect.slope[i,][10]<-summary(ha3)[8]$r.squared
	collect.slope[i,][11]<-mean(datay1b$Pairwise)
	collect.slope[i,][12]<-ha4$coefficients[2]
	collect.slope[i,][13]<-summary(ha4)[8]$r.squared
	collect.slope[i,][14]<-mean(datay2b$Pairwise)



#collect.slope[i,][6]<-lm(Pairwise~ln.dist,data=datay2b)$coefficients[2]
	#collect.slope[i,][7]<-lm(Pairwise~ln.dist,data=datay1c)$coefficients[2]
	print(i)
}
collect.slope<-as.matrix(collect.slope)
write.csv(collect.slope,"result_more.csv")





